<?php

namespace Drupal\paragraphs_sort_alphabetically_widget\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Attribute\FieldWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\paragraphs\Plugin\Field\FieldWidget\ParagraphsWidget;

/**
 * Provides a Paragraphs widget with alphabetic sorting support.
 */
#[FieldWidget(
  id: "paragraphs_alpha_sort",
  label: new TranslatableMarkup('Paragraphs (sort alphabetically)'),
  field_types: ["entity_reference_revisions"]
)]
class ParagraphsAlphaSortWidget extends ParagraphsWidget {

  use ParagraphsAlphaSortHelperTrait;

  /**
   * {@inheritdoc}
   */
  public function formMultipleElements(FieldItemListInterface $items, array &$form, FormStateInterface $form_state): array {
    $element = parent::formMultipleElements($items, $form, $form_state);
    return $this->addSortButton($element, $items);
  }

}
