<?php

namespace Drupal\paragraphs_sort_alphabetically_widget\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Attribute\FieldWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\paragraphs\Plugin\Field\FieldWidget\InlineParagraphsWidget;

/**
 * Provides a Paragraphs widget with alphabetic sorting support, using legacy.
 */
#[FieldWidget(
  id: "paragraphs_alpha_sort_legacy",
  label: new TranslatableMarkup('Paragraphs Legacy (sort alphabetically)'),
  field_types: ["entity_reference_revisions"]
)]
class ParagraphsAlphaSortWidgetLegacy extends InlineParagraphsWidget {

  use ParagraphsAlphaSortHelperTrait;

  /**
   * {@inheritdoc}
   */
  public function formMultipleElements(FieldItemListInterface $items, array &$form, FormStateInterface $form_state): array {
    $element = parent::formMultipleElements($items, $form, $form_state);
    return $this->addSortButton($element, $items);
  }

}
